Index: uk/me/parabola/mkgmap/build/MapBuilder.java
===================================================================
--- src/uk/me/parabola/mkgmap/build/MapBuilder.java	(revision 1634)
+++ src/uk/me/parabola/mkgmap/build/MapBuilder.java	(working copy)
@@ -334,7 +334,10 @@
 			if(p.isExit()) {
 				processExit(map, (MapExitPoint)p);
 			}
-			else if(!p.isCity() && !p.hasExtendedType() && (p.isRoadNamePOI() || poiAddresses)) {
+			else if(!p.isCity() && !p.hasExtendedType() && (p.isRoadNamePOI() || poiAddresses)
+				&& ((p.getType() < 0x1c00) || (p.getType() >= 0x1d00))
+				&& (p.getType() < 0x4100)) {
+
 				boolean doAutofill;
 				if(locationAutofillLevel > 0 || p.isRoadNamePOI())
 					doAutofill = true;
@@ -353,7 +356,7 @@
 					CountryStr = locator.fixCountryString(CountryStr);
 
 				boolean guessed = false;
-				if(CountryStr == null || RegionStr == null || (ZipStr == null && CityStr == null))
+				if((CountryStr == null || RegionStr == null || (ZipStr == null && CityStr == null)) & p.getStreet() != null)
 				{
 						MapPoint nextCity = locator.findByCityName(p);
 						
@@ -440,11 +443,6 @@
 					Label streetName = lbl.newLabel(p.getStreet());
 					r.setStreetName(streetName);			  
 				}
-				else if (guessed && locationAutofillLevel > 0)
-				{
-					Label streetName = lbl.newLabel("FIX MY ADDRESS");
-					r.setStreetName(streetName);		
-				}
 
 				if(p.getHouseNumber() != null)
 				{
